--- old/usr/src/lib/libdtrace/common/dt_consume.c	2014-01-14 16:48:02.933067284 -0500
+++ new/usr/src/lib/libdtrace/common/dt_consume.c	2014-01-14 16:48:02.946435694 -0500
@@ -1381,8 +1381,8 @@
 				    "%s`%s", dt_basename(objname), name);
 			}
 		} else if (str != NULL && str[0] != '\0' && str[0] != '@' &&
-		    (P != NULL && ((map = Paddr_to_map(P, pc[i])) == NULL ||
-		    (map->pr_mflags & MA_WRITE)))) {
+		    (P == NULL || (map = Paddr_to_map(P, pc[i])) == NULL ||
+		    map->pr_mflags & MA_WRITE)) {
 			/*
 			 * If the current string pointer in the string table
 			 * does not point to an empty string _and_ the program
@@ -1394,7 +1394,10 @@
 			 * identify.  If we have a string for a program
 			 * counter that falls in a segment that isn't
 			 * writable, we assume that we have fallen into this
-			 * case and we refuse to use the string.
+			 * case and we refuse to use the string.  Finally,
+			 * note that if we could not grab the process (e.g.,
+			 * because it exited), the information from the helper
+			 * is better than nothing.
 			 */
 			(void) snprintf(c, sizeof (c), "%s", str);
 		} else {
